#include "stdafx.h"
#include "WaveEd.h"
#include "RenderDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CRenderDialog::CRenderDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CRenderDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRenderDialog)
	m_filename = _T("");
	//}}AFX_DATA_INIT
}


void CRenderDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRenderDialog)
	DDX_Control(pDX, IDCANCEL, m_cancelbutton);
	DDX_Control(pDX, IDC_RENDERSTART, m_startbutton);
	DDX_Control(pDX, IDC_PROGRESS1, m_Progress);
	DDX_Text(pDX, IDC_EDIT1, m_filename);
	DDV_MaxChars(pDX, m_filename, 256);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRenderDialog, CDialog)
	//{{AFX_MSG_MAP(CRenderDialog)
	ON_BN_CLICKED(IDC_RENDERSELECT, OnRenderselect)
	ON_BN_CLICKED(IDC_RENDERSTART, OnRenderstart)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRenderDialog message handlers

void CRenderDialog::OnRenderselect() 
{
	CFileDialog saveDialog(false, "wav", "dump.wav", OFN_ENABLESIZING,
								"Wave files (*.wav)|*.wav|", this);
	
	if (saveDialog.DoModal() == IDOK)
	{	
	
		m_filename = saveDialog.GetPathName();
		UpdateData(false);
	}
	
}

void CRenderDialog::OnRenderstart() 
{
	UpdateData(true);
	char buff[2048];
	DWORD lastFilled;
	WaveFile file;
		
	m_startbutton.EnableWindow(false);
	m_cancelbutton.EnableWindow(false);
	file.Open(m_filename, WF_WRITE);
	m_Progress.SetRange32(0, pEngine->GetWorkspaceSize());
	m_Progress.SetPos(0);

	file.WriteHeader(pEngine->GetWorkspaceSize());

	for (DWORD i = 0; i < pEngine->GetWorkspaceSize(); i += 512)
	{
		pSource->GetDataBlock(buff, &lastFilled, i);
		file.PutDataBlock(buff, lastFilled);
		m_Progress.SetPos(i);
	}

	file.Close();
	m_cancelbutton.EnableWindow(true);
	this->SetDefID(IDCANCEL);
}

void CRenderDialog::SetupPointers(VSTPlugin* src, WaveEngine* engine)
{
	pSource = src;
	pEngine = engine;
}
