#include "stdafx.h"
#include "waveengine.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

WaveEngine::WaveEngine()
{
	//IsEmpty = true;
}	

WaveEngine::~WaveEngine()
{
	New();
}

bool WaveEngine::LoadWave(const char* fName)
{
	WaveFile* FileToInsert = new WaveFile;
	RegionList* TmpRegion = new RegionList;

	if (IsEmpty())
	{
		if (!FileToInsert->Open(fName, WF_READ))
		{
			delete FileToInsert;
			delete TmpRegion;
			return false;
		}
		else
		{
			TmpRegion->Wave = FileToInsert;
			TmpRegion->inWaveStart = 0;
			TmpRegion->inWaveEnd = FileToInsert->GetDataSize();
	
			Workspace.push_back(TmpRegion);
			OpenWaves.push_back(FileToInsert);
		}

	}
	else 
	{
		if (!FileToInsert->Open(fName, WF_READ))
		{
			delete FileToInsert;
			delete TmpRegion;
			return false;
		}
		OpenWaves.push_back(FileToInsert);
		delete TmpRegion;

	}
	return true;
}

void WaveEngine::New()
{
	if (!IsEmpty())
	{
		for (list<WaveFile*>::iterator i = OpenWaves.begin(); i !=OpenWaves.end(); ++i)
		{
			delete (*i);
		}
		OpenWaves.clear();

		for(list<RegionList*>::iterator j = Workspace.begin(); j !=Workspace.end(); ++j)
		{
			//delete (*j)->Wave; Skasowane wczesniej!
			delete (*j);
		}
		Workspace.clear();
		
		for(list<RegionList*>::iterator k = Workspace.begin(); k !=Workspace.end(); ++k)
		{
			delete (*k);
		}
		Clipboard.clear(); // To do przemyslenia ...
	}
}

void WaveEngine::Delete(DWORD cut_begin, DWORD cut_end)
{
	DWORD ActualPosition = 0;
	RegionList* ToInsert;
	DWORD tmpLength = 0;

	for(list<RegionList*>::iterator j = Workspace.begin(); j !=Workspace.end(); ++j)
	{
		tmpLength = (*j)->Length();
		if((ActualPosition + (*j)->Length() >= cut_begin) && (ActualPosition < cut_end))
			//inaczej region nie objety wycinaniem
		{

			if (ActualPosition >= cut_begin)
			{
				if ( (ActualPosition + (*j)->Length()) <= cut_end )
				{
					//(*j)->inWaveStart = 0;
					//(*j)->inWaveEnd = 0;
					Workspace.erase(j);
					--j;
				}
				else
				{
					(*j)->inWaveStart += cut_end - ActualPosition;
				}
			}
			else
			{
				if( (ActualPosition + (*j)->Length()) > cut_end)
				{
					ToInsert = new RegionList;

					ToInsert->Wave = (*j)->Wave;
					ToInsert->inWaveStart = (*j)->inWaveStart;
					ToInsert->inWaveEnd = (*j)->inWaveStart + (cut_begin - ActualPosition);
					Workspace.insert(j, ToInsert);
				
					(*j)->inWaveStart = (*j)->inWaveStart + (cut_end - ActualPosition);
					//To sie nie zmienia -> *j->inWaveEnd;
					//*j->Wave -> tez nie! ...
				}
				else
				{
					(*j)->inWaveEnd = (*j)->inWaveStart + (cut_begin - ActualPosition);
				}
			}
		}
		ActualPosition += tmpLength;
	}
}

void WaveEngine::Copy(DWORD copy_begin, DWORD copy_end)
{
	DWORD ActualPosition = 0;
	
	Clipboard.clear();

	for(list<RegionList*>::iterator j = Workspace.begin(); j !=Workspace.end(); ++j)
	{

		if((ActualPosition + (*j)->Length() >= copy_begin) && (ActualPosition < copy_end))
		//inaczej region nie objety kopiowaniem.
		{
			RegionList* ToInsert = new RegionList;
			ToInsert->Wave = (*j)->Wave;

			if (ActualPosition >= copy_begin)
			{
				ToInsert->inWaveStart = (*j)->inWaveStart;

				if ( (ActualPosition + (*j)->Length()) <= copy_end )
				{
					ToInsert->inWaveEnd = (*j)->inWaveEnd;
				}
				else
				{
					ToInsert->inWaveEnd = (*j)->inWaveStart + (copy_end - ActualPosition);
				}
			}
			else
			{
				if( (ActualPosition + (*j)->Length()) > copy_end)
				{
					ToInsert->inWaveStart = (*j)->inWaveStart + (copy_begin - ActualPosition);
					ToInsert->inWaveEnd = (*j)->inWaveStart + (copy_end - ActualPosition); 
				}
				else
				{
					ToInsert->inWaveStart = (*j)->inWaveStart + (copy_begin - ActualPosition);
					ToInsert->inWaveEnd = (*j)->inWaveEnd;
				}
			}

		Clipboard.push_back(ToInsert);
		}
		ActualPosition += (*j)->Length();
	}
}

void WaveEngine::Cut(DWORD cut_begin, DWORD cut_end)
{
	Copy(cut_begin, cut_end);
	Delete(cut_begin, cut_end);
}

void WaveEngine::Paste(DWORD paste_begin)
{
	list<RegionList*>::iterator i = Workspace.begin();
	list<RegionList*>::iterator tmpi = Clipboard.end();
	DWORD ActualPosition = 0;
	RegionList* ToInsert = new RegionList;

	if ( Clipboard.size() )
	{
		while ( i != Workspace.end() )
		{
			if (ActualPosition == paste_begin)
			{
				Workspace.insert( i, Clipboard.begin(), Clipboard.end());
				break;
			}
			else if ( (ActualPosition < paste_begin) && ( (ActualPosition + (*i)->Length()) >= paste_begin) )
			{
				ToInsert->Wave = (*i)->Wave;
				ToInsert->inWaveStart = (*i)->inWaveStart;
				ToInsert->inWaveEnd = (*i)->inWaveStart + (paste_begin - ActualPosition);
				Workspace.insert(i, ToInsert);

				(*i)->inWaveStart += ToInsert->Length();

				Workspace.insert(i, Clipboard.begin(), Clipboard.end());
				break;
			}

			ActualPosition += (*i)->Length();
			i++;
		}
	}
}

DWORD WaveEngine::GetWorkspaceSize()
{
	DWORD size = 0;

	for (list<RegionList*>::iterator i = Workspace.begin(); i !=Workspace.end(); i++)
	{
		size += (*i)->Length();
	}

	return size;
}

DWORD WaveEngine::GetWaveSize(int num)
{
	list<WaveFile*>::iterator i = OpenWaves.begin();

	if (num < OpenWaves.size())
	{
		while (num-- != 0)
		{
			i++;
		}
	}
	return ((*i)->GetDataSize() /*<<2*/);
	//A moze to mnozyc????
}

bool WaveEngine::GetDataBlock(char* buff, DWORD BlockSize, DWORD* LastFilled, DWORD pos)
{
	DWORD ActualPosition = 0;
	
	if (buff && BlockSize)
	{
		for(list<RegionList*>::iterator i = Workspace.begin(); i !=Workspace.end(); i++)
		{
			if ( (ActualPosition <= pos) && (ActualPosition+(*i)->Length() >= pos) )
			{
				(*i)->Wave->Seek(pos - ActualPosition + (*i)->inWaveStart);
				*LastFilled = (*i)->Wave->GetDataBlock(buff, BlockSize);
				return true;
			}
			
			ActualPosition += (*i)->Length();
		}
	}
	return false;
}

bool WaveEngine::GetWaveDataBlock(int num, char* buff, DWORD BlockSize, DWORD* LastFilled, DWORD pos)
{
	list<WaveFile*>::iterator i = OpenWaves.begin();

	if (buff && BlockSize)
	{
		if (num < OpenWaves.size())
		{
		while (num-- != 0)
			{
				i++;
			}
		}

		(*i)->Seek(pos);
		*LastFilled = (*i)->GetDataBlock(buff, BlockSize);
		return true;
	}
	else return false;
}

bool WaveEngine::IsEmpty()
{
	if (!OpenWaves.size()) return true;
	else return false;
}

bool WaveEngine::IsClipboardEmpty(void)
{
	if (!Clipboard.size()) return true;
	else return false;
}

void WaveEngine::SingleCopy(DWORD copy_begin, DWORD copy_end, UCHAR Num)
{
	RegionList* ToInsert = new RegionList;
	list<WaveFile*>::iterator i = OpenWaves.begin();

	Clipboard.clear();

	while(Num--) i++;

	ToInsert->inWaveStart = copy_begin;
	ToInsert->inWaveEnd = copy_end;
	ToInsert->Wave = (*i);
	
	Clipboard.push_back(ToInsert);
}
