#pragma once
#include <list>
#include "wavefile.h"
using namespace std;

struct RegionList
{
	DWORD Length() { return inWaveEnd - inWaveStart;}
	DWORD inWaveStart;
	DWORD inWaveEnd;
	WaveFile* Wave;
};

class WaveEngine
{
public:

	WaveEngine();
	~WaveEngine();

	void Cut(DWORD cut_begin, DWORD cut_end);
	void Copy(DWORD copy_begin, DWORD copy_end);
	void WaveEngine::SingleCopy(DWORD copy_begin, DWORD copy_end, UCHAR Num);
	void Paste(DWORD paste_begin);
	void Delete(DWORD cut_begin, DWORD cut_end);
	void New(void);

	void VSTProcessSelection(void);
	bool LoadWave(const char* fName);
//	void RenderToFile(const char* fName, VSTPlugin* input);

	bool  GetDataBlock(char* buff, DWORD BlockSize, DWORD* LastFilled, DWORD pos);
	bool  GetWaveDataBlock(int num, char* buff, DWORD BlockSize, DWORD* LastFilled, DWORD pos);
	DWORD GetWaveSize(int num);
	DWORD GetWorkspaceSize(void);
	bool  IsEmpty(void);
	bool  IsClipboardEmpty(void);

private:
	
	list<RegionList*> Workspace;
	list<RegionList*> Clipboard;

	list<WaveFile*> OpenWaves;

	void Optimize(void);
};
