#include "stdafx.h"
#include "VSTPlugin.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

////////////////////////////
DWORD		VSTPlugin::SampleRate;
DWORD		VSTPlugin::BlockSize;
AEffect*	VSTPlugin::m_pOpenEffect;
HFONT		VSTPlugin::hFont;
HWND		VSTPlugin::m_hWnd;
////////////////////////////

//#define ID_TRACKBAR 1000

VSTPlugin::VSTPlugin(HINSTANCE hInstance, WaveEngine* pServer)
{
	SampleRate = 0;
	BlockSize = 0;

	TimeInfo.samplePos = 0;
	TimeInfo.flags = 0;

	INITCOMMONCONTROLSEX lpInitCtrls;
	lpInitCtrls.dwSize = sizeof(INITCOMMONCONTROLSEX);
	lpInitCtrls.dwICC  = ICC_BAR_CLASSES;
	InitCommonControlsEx(&lpInitCtrls);


	m_hInstance = hInstance;
	DataServer = pServer;
}

VSTPlugin::~VSTPlugin()
{
	DeleteObject(hFont);
	//GlobalFree(hGlobal);!!!!!!!!!!
	
	delete [] fWorkBuffer[0];
	delete [] fWorkBuffer[1];
	delete [] cWorkBuffer;

	for (list<AllPluginsEntry>::iterator i = AllPluginNames.begin(); i != AllPluginNames.end(); ++i)
	{
		delete [] (*i).Name;
		delete [] (*i).DllName;
	}
	AllPluginNames.clear();

	while (!PluginChain.empty()) unLoad(0,0);
	
}

void VSTPlugin::SetConfig(DWORD sRate, DWORD bSize, char* dir)
{
	TimeInfo.sampleRate = SampleRate = sRate;
	BlockSize = bSize;
	//CopyMemory(VSTDir, dir, lstrlen(dir)+1);
	lstrcpy(VSTDir, dir);

	fWorkBuffer[0] = new float[BlockSize/4];
	fWorkBuffer[1] = new float[BlockSize/4];
	cWorkBuffer = new char[BlockSize];
}


AEffect* VSTPlugin::Load(char* dllName, BYTE Pos, bool flag, HMODULE* pEnumHandle)
{
	HMODULE* hDll = new HMODULE;
	PlugsMain mainProc;
	AEffect* pTmpAEffect;
	Effect* pTmpEffectStruct = 0;
	BYTE i2 = 0;
	char dllPath[MAX_PATH];

	lstrcpy(dllPath, VSTDir);
	lstrcat(dllPath, dllName);

	if (!BlockSize || !SampleRate)
	{
		delete hDll;
		return false;
	}
	if (!(*hDll = AfxLoadLibrary(dllPath)))
	{
		DWORD err = GetLastError();
		delete hDll;
		return false;
	}
	//else
	if (!(mainProc =(PlugsMain) GetProcAddress(*hDll, "main")))
	{
		if(!AfxFreeLibrary(*hDll)) AfxMessageBox(IDS_MSG_DLLUNLOADFAILED, MB_OK, 0);
		delete hDll;
		return false;
	}
	//else
	pTmpAEffect = mainProc(&MasterCallback);
	if (!pTmpAEffect || !(pTmpAEffect->magic == kEffectMagic))
	{
		if(!AfxFreeLibrary(*hDll)) AfxMessageBox(IDS_MSG_DLLUNLOADFAILED, MB_OK, 0);
		delete hDll;
		return false;
	}
	//else
	Dispatch( pTmpAEffect, effOpen, 0, 0, NULL, 0.0f);
	Dispatch( pTmpAEffect, effSetProgram  , 0, 0, NULL, 0.0f);
	Dispatch( pTmpAEffect, effSetSampleRate,0, 0, NULL, SampleRate);
	Dispatch( pTmpAEffect, effSetBlockSize, 0, BlockSize, NULL, 0.0f);
	//isInitialized = true;

	if (flag)
	{
		//*pEnumHandle = 0;
		pTmpEffectStruct = new Effect;
		pTmpEffectStruct->phDll = hDll;
		pTmpEffectStruct->pAEffect = pTmpAEffect;

		if (PluginChain.size() > 1)
		{
			for (list<Effect*>::iterator i = PluginChain.begin(); i != PluginChain.end(); ++i)
			{
				if (i2 == Pos)
				{
					PluginChain.insert(i, pTmpEffectStruct);
					break;
				}
				else i2++;
			}
		}
		else PluginChain.push_back(pTmpEffectStruct);
	}
	else
	{
		*pEnumHandle = *hDll; // A wiec jesli ENUM, to zwracamy handla pod *.
		delete hDll;
	}
	_ASSERT(_CrtCheckMemory());//, zeby enum mogl do wypieprzyc.
	return pTmpAEffect;
	
}

bool VSTPlugin::unLoad(BYTE Num, AEffect* pUnEffect) //pUnEffect = 0 jesli enumerator!
{
	Effect* pTmpEffectStruct = 0;
	AEffect* pTmpAEffect = pUnEffect;
	BYTE Cnt = 0;

	if (!pUnEffect)
	{
		if (PluginChain.empty()) return true;

		for (list<Effect*>::iterator i = PluginChain.begin(); i != PluginChain.end(); ++i)
		{
			if (Cnt == Num)
			{
				pTmpEffectStruct = *i;
				PluginChain.erase(i);
				break;
			}
			else Cnt++;
		}
		if (!pTmpEffectStruct) //Jesli num wiekszy niz liczba pluginow.
		{
			pTmpEffectStruct = PluginChain.back();
			PluginChain.erase(--PluginChain.end());
		}
		pTmpAEffect = pTmpEffectStruct->pAEffect;
	}
	_ASSERT(_CrtCheckMemory());

	Dispatch( pTmpAEffect, effMainsChanged, 0, 0, NULL, 0.0f);
	Dispatch( pTmpAEffect, effClose,        0, 0, NULL, 0.0f);
	SendMessage(m_hWnd, WM_CLOSE, NULL, NULL);
	//DLL odladowuje sie w funkcji EnumPlugins!

	if (pTmpEffectStruct)
	{
		//To wprawdzie jest wskaznikiem, ale nie jest alokowane w programie!!!
		//delete pTmpEffectStruct->pAEffect;
		
		if (!AfxFreeLibrary(*(pTmpEffectStruct->phDll)))
		{
			AfxMessageBox(IDS_MSG_DLLUNLOADFAILED, MB_OK, 0);
			return false;
		}
		else
		{
			GlobalUnlock(pTmpEffectStruct->hGlobal);
			GlobalFree(pTmpEffectStruct->hGlobal);
			delete pTmpEffectStruct->phDll;
			delete pTmpEffectStruct;
			_ASSERT(_CrtCheckMemory());
			return true;
		}
	}
	else return true;
}

long VSTCALLBACK VSTPlugin::MasterCallback(AEffect *effect, long opcode, long index,
	  long value, void *ptr, float opt)
{
	switch (opcode)
	{
	case audioMasterAutomate:	return 0;		// index, value, returns 0
	case audioMasterVersion:	return 2;		// vst version, currently 2 (0 for older)
	case audioMasterCurrentId:	return 'KUPA';	// returns the unique id of a plug that's currently
												// loading
	case audioMasterIdle:
		{
			effect->dispatcher(effect, effEditIdle, 0, 0, NULL, 0.0f);
			return 0;
			break;
		}										// call application idle routine (this will
												// call effEditIdle for all open editors too) 

	case audioMasterPinConnected:	return 0;	// inquire if an input or output is beeing connected;
												// index enumerates input or output counting from zero,
												// value is 0 for input and != 0 otherwise. note: the
												// return value is 0 for <true> such that older versions
												// will	always return true.


//////////////AeffectX////////////////
	case audioMasterWantMidi:	break;			// <value> is a filter which is currently ignored
	case audioMasterGetTime:	break;
		/*{
			value = 0;
			return &TimeInfo;
		}*/										// returns const VstTimeInfo* (or 0 if not supported)
												// <value> should contain a mask indicating which fields are required
												// (see valid masks above), as some items may require extensive
												// conversions
	case audioMasterProcessEvents:	break;	// VstEvents* in <ptr>
	case audioMasterSetTime:		break;	// VstTimenfo* in <ptr>, filter in <value>, not supported
	case audioMasterTempoAt:		break;	// returns tempo (in bpm * 10000) at sample frame location passed in <value>

	// parameters
	case audioMasterGetNumAutomatableParameters:	break;
	case audioMasterGetParameterQuantization:		break;	// returns the integer value for +1.0 representation,
															// or 1 if full single float precision is maintained
															// in automation. parameter index in <value> (-1: all, any)
	// connections, configuration
	case audioMasterIOChanged:		break;		// numInputs and/or numOutputs has changed
	case audioMasterNeedIdle:
		{
			effect->dispatcher(effect, effIdle, 0, 0, NULL, 0.0f);
			return 1;
		}										// plug needs idle calls (outside its editor window)
	case audioMasterSizeWindow:			break;	// index: width, value: height
	case audioMasterGetSampleRate:		return SampleRate;//SampleRate;
	case audioMasterGetBlockSize:		return BlockSize;
	case audioMasterGetInputLatency:	break;
	case audioMasterGetOutputLatency:	break;
	case audioMasterGetPreviousPlug:	break;			// input pin in <value> (-1: first to come), returns cEffect*
	case audioMasterGetNextPlug:		break;			// output pin in <value> (-1: first to come), returns cEffect*

	// realtime info
	case audioMasterWillReplaceOrAccumulate:	break;	// returns: 0: not supported, 1: replace, 2: accumulate
	case audioMasterGetCurrentProcessLevel:		break;	// returns: 0: not supported,
														// 1: currently in user thread (gui)
														// 2: currently in audio thread (where process is called)
														// 3: currently in 'sequencer' thread (midi, timer etc)
														// 4: currently offline processing and thus in user thread
														// other: not defined, but probably pre-empting user thread.
	case audioMasterGetAutomationState:	break;			// returns 0: not supported, 1: off, 2:read, 3:write, 4:read/write

	// offline
	case audioMasterOfflineStart:	break;
	case audioMasterOfflineRead:	break;				// ptr points to offline structure, see below. return 0: error, 1 ok
	case audioMasterOfflineWrite:	break;				// same as read
	case audioMasterOfflineGetCurrentPass:	break;
	case audioMasterOfflineGetCurrentMetaPass:	break;	

	// other
	case audioMasterSetOutputSampleRate:	break;		// for variable i/o, sample rate in <opt>
	case audioMasterGetSpeakerArrangement:	break;		// (long)input in <value>, output in <ptr>
	case audioMasterGetVendorString:
		{
			CopyMemory(ptr, "Fidelup ejw editor", 20);
			break;
		}												// fills <ptr> with a string identifying the vendor (max 64 char)
	case audioMasterGetProductString:
		{
			CopyMemory(ptr, "Fidelup softer", 16);
			break;
		}												// fills <ptr> with a string with product name (max 64 char)
	case audioMasterGetVendorVersion:	return 1;		// returns vendor-specific version
	case audioMasterVendorSpecific:		break;			// no definition, vendor specific handling
	case audioMasterSetIcon:			break;			// void* in <ptr>, format not defined yet
	case audioMasterCanDo:				break;		// string in ptr, see below
	case audioMasterGetLanguage:		return kVstLangEnglish;	// see enum
	case audioMasterOpenWindow:			break;			// returns platform specific ptr
	case audioMasterCloseWindow:		break;			// close window, platform specific handle in <ptr>
	case audioMasterGetDirectory:		break;			// get plug directory, FSSpec on MAC, else char*
	case audioMasterUpdateDisplay:		break;			// something has changed, update 'multi-fx' display

	default: return 0;
	}
	return 0;
}

long VSTPlugin::Dispatch(AEffect* pEffect, long opCode, long index, long value, void *ptr, float opt)
{
	return pEffect->dispatcher(pEffect, opCode, index, value, ptr, opt);
}

bool VSTPlugin::isSynth(AEffect* pEffect)
{
	return (pEffect->flags & effFlagsIsSynth) ? true : false;
}

/*bool VSTPlugin::SetProgram(BYTE PlugNumber, int index)
{

		Dispatch(effSetProgram,	0, index, NULL, 0.0f);
}

int VSTPlugin::GetCurrentProgram(BYTE PlugNumber)
{
	if (isInitialized)
	{
		return Dispatch(effGetProgram, 0, 0, NULL, 0.0f);
	}
	else return 0;
}

bool VSTPlugin::SetProgramName(BYTE PlugNumber, char* Name)
{
	if (isInitialized)
	{
		Dispatch(effSetProgramName, 0, 0, Name, 0.0f);
		return true;
	}
	else return false;
}

bool VSTPlugin::GetProgramName(BYTE PlugNumber, char* Name)
{
	if (isInitialized)
	{
		Dispatch(effGetProgramName, 0, 0, Name, 0.0f);
		return true;
	}
	else return false;
}

void VSTPlugin::GetParamLabel(BYTE PlugNumber, int index, char* Label)
{
	if (isInitialized)
	{
		Dispatch(effGetParamLabel, index, 0, Label, 0.0f);
		return true;
	}
	else return false;
}

bool VSTPlugin::GetParamDisplay(BYTE PlugNumber, int index, char* Display)
{
	if (isInitialized)
	{
		Dispatch(effGetParamDisplay, index, 0, Display, 0.0f);
		return true;
	}
	else return false;
}

bool VSTPlugin::GetParamName(BYTE PlugNumber, int index, char* Name)
{
	if (isInitialized)
	{
		Dispatch(effGetParamName, index, 0, Name, 0.0f);
		return true;
	}
	else return false;
}
*/
void VSTPlugin::UpdateSamplePos(double pos)
{
	TimeInfo.samplePos = pos;
}

bool VSTPlugin::EnumPlugins(void)
{
	AllPluginsEntry Entry;
	HMODULE hTmpEnumHandle;
	AEffect* tmpAEffect;
	char SearchPath[MAX_PATH], *tmpName, *tmpDllName;
	HANDLE hSearchHandle;
	WIN32_FIND_DATA FindData;

	lstrcpy(SearchPath, VSTDir);
	lstrcat(SearchPath, "*.dll");
	hSearchHandle = FindFirstFile(SearchPath, &FindData);
	if (hSearchHandle == INVALID_HANDLE_VALUE) return false;
	//else
	do
	{
		if ( tmpAEffect = Load(FindData.cFileName, 0, VST_ENUMERATE, &hTmpEnumHandle))
		{
			tmpName = new char[32];
			tmpDllName = new char[MAX_PATH];
			lstrcpy(tmpDllName, FindData.cFileName);
			
			//Jesli nie uda sie pobrac nazwy(DUUUZO pluginow nie podaje ;((( )
			if(!Dispatch(tmpAEffect, effGetEffectName, 0, 0, tmpName, 0.0f))
			{
				lstrcpyn(tmpName, FindData.cFileName, lstrlen(FindData.cFileName) - 3);
			}
			Entry.DllName = tmpDllName;
			Entry.Name = tmpName;
			AllPluginNames.push_back(Entry);
			unLoad(0, tmpAEffect);
			if(!AfxFreeLibrary(hTmpEnumHandle)) AfxMessageBox(IDS_MSG_DLLUNLOADFAILED, MB_OK, 0);
		}
	}
	while (FindNextFile(hSearchHandle, &FindData));
	_ASSERT(_CrtCheckMemory());
	return true;
}

void VSTPlugin::OpenPluginDialog(BYTE Num, BYTE NumInMenu)
{
	char ParamName[9], ParamDisplay[17], ParamLabel[9];
	AEffect* pTmpAEffect;
	list<Effect*>::iterator i;
	int j;
	BYTE nameCount = NumInMenu;
	char* pluginName;
	
	DLGTEMPLATE*		pDt;
	DLGITEMTEMPLATE*	pDit;
	WORD*				pDPtr;
	HWND				hDlgItem;
	//float				ParamValue;
	BYTE				bParamValue;

	//own editor
	ERect* ppWinSize;

	SendMessage(m_hWnd, WM_CLOSE, NULL, NULL);

	for (list<AllPluginsEntry>::iterator itr = AllPluginNames.begin(); itr != AllPluginNames.end(); ++itr)
	{
		if (!(nameCount--)) break;		
	}
	pluginName = (*itr).Name;

		
	if (PluginChain.empty())
	{
		MessageBox(AfxGetMainWnd()->m_hWnd, "No plugins loaded.", "Info...", MB_OK | MB_ICONHAND);
		return;
	}

	i = PluginChain.begin();
	for (j = 0; j < Num; j++)
	{
		
		if ( i == PluginChain.end() )
		{
			--i;
			break;
		}
		i++;
	}
	m_pOpenEffect = pTmpAEffect = (*i)->pAEffect;

	//Teraz naley sprawdzi, czy plugin ma swj wasny edytor
	if (m_pOpenEffect->flags & effFlagsHasEditor)
	{
		m_pOpenEffect->dispatcher(m_pOpenEffect, effEditGetRect, 0, 0, &ppWinSize, 0.0f);
		(*i)->hGlobal = GlobalAlloc(GMEM_ZEROINIT, 16384);
		pDt = (DLGTEMPLATE*)GlobalLock((*i)->hGlobal);
		pDt->style = WS_POPUP | WS_CAPTION | WS_SYSMENU ;
		pDt->dwExtendedStyle = WS_EX_TOOLWINDOW;
		pDt->cdit = 0;
		pDt->x = 50; pDt->cx = (*ppWinSize).right/2; //Nie kumam - /2 ...
		pDt->y = 50; pDt->cy = (*ppWinSize).bottom/2;

		pDPtr = (WORD*) (pDt + 1);
		*pDPtr++ = 0; //No menu
		*pDPtr++ = 0; //No own class

		pDPtr += MultiByteToWideChar(CP_ACP, 0, pluginName, -1, pDPtr, 50);
		
		GlobalUnlock((*i)->hGlobal); 
		m_hWnd = CreateDialogIndirect(m_hInstance, (DLGTEMPLATE*)(*i)->hGlobal, AfxGetMainWnd()->m_hWnd, MainVSTDlgProc2);
		m_pOpenEffect->dispatcher(m_pOpenEffect, effEditOpen, 0, 0, m_hWnd, 0.0f);
		ShowWindow(m_hWnd, SW_SHOW);
		
		_ASSERT(_CrtCheckMemory());
		return;
	}

	(*i)->hGlobal = GlobalAlloc(GMEM_ZEROINIT, 16384);
	pDt = (DLGTEMPLATE*)GlobalLock((*i)->hGlobal);
	pDt->style = WS_POPUP | WS_CAPTION | WS_SYSMENU;
	pDt->dwExtendedStyle = WS_EX_TOOLWINDOW;
	pDt->cdit = m_pOpenEffect->numParams*3;
	pDt->x = 50; pDt->cx = 210;
	pDt->y = 50; pDt->cy = m_pOpenEffect->numParams*10;

	pDPtr = (WORD*) (pDt + 1);
	*pDPtr++ = 0; //No menu
	*pDPtr++ = 0; //No own class

	pDPtr += MultiByteToWideChar(CP_ACP, 0, pluginName, -1, pDPtr, 50);

	//Kontrolki "Static" - nazwy suwakw

	for (j = 0; j < m_pOpenEffect->numParams; j++)
	{
		pDPtr = Align2DWORD(pDPtr);
		pDit = (DLGITEMTEMPLATE*) pDPtr;
		pDit->x = 0;
		pDit->cx = 50;
		pDit->y = 10*j; pDit->cy = 9;
		pDit->id = ID_VST_STATIC + j; //!!!!
		pDit->style = WS_CHILD | WS_VISIBLE | SS_RIGHT;

		pDPtr = (WORD*) (pDit + 1);
		*pDPtr++ = 0xFFFF;
		*pDPtr++ = 0x0082; // static class

		m_pOpenEffect->dispatcher(m_pOpenEffect, effGetParamName, j, 0, ParamName, 0.0f);
		pDPtr += MultiByteToWideChar(CP_ACP, 0, ParamName, -1, pDPtr, 20);

		//pDPtr = Align2DWORD(pDPtr);
		*pDPtr++ = 0;
	}

	//Suwaki

	for (j = 0; j < m_pOpenEffect->numParams; j++)
	{
		pDPtr = Align2DWORD(pDPtr);
		pDit = (DLGITEMTEMPLATE*) pDPtr;
		pDit->x = 51; pDit->cx = 100;
		pDit->y = 10*j; pDit->cy = 9;
		pDit->id = ID_VST_STATIC + m_pOpenEffect->numParams + j;
		pDit->style = WS_CHILD | WS_VISIBLE;

		pDPtr = (WORD*) (pDit + 1);
		pDPtr += MultiByteToWideChar(CP_ACP, 0, "msctls_trackbar32", -1, pDPtr, 50);

		pDPtr = Align2DWORD(pDPtr);
		*pDPtr++ = 0;
	}

	//Wybrane wartoci;

	for (j = 0; j < m_pOpenEffect->numParams; j++)
	{
		pDPtr = Align2DWORD(pDPtr);
		pDit = (DLGITEMTEMPLATE*) pDPtr;
		pDit->x = 152; pDit->cx = 50;
		pDit->y = 10*j; pDit->cy = 9;
		pDit->id = ID_VST_STATIC + m_pOpenEffect->numParams*2 + j;
		pDit->style = WS_CHILD | WS_VISIBLE | SS_LEFT;

		pDPtr = (WORD*) (pDit + 1);
		*pDPtr++ = 0xFFFF;
		*pDPtr++ = 0x0082; // static class

		m_pOpenEffect->dispatcher(m_pOpenEffect, effGetParamDisplay, j, 0, ParamDisplay, 0.0f);
		m_pOpenEffect->dispatcher(m_pOpenEffect, effGetParamLabel, j, 0, ParamLabel, 0.0f);
		lstrcat(ParamDisplay, ParamLabel);
		pDPtr += MultiByteToWideChar(CP_ACP, 0, ParamDisplay, -1, pDPtr, 20);

		//pDPtr = Align2DWORD(pDPtr);
		*pDPtr++ = 0;
	}

	GlobalUnlock((*i)->hGlobal); 
    m_hWnd = CreateDialogIndirect(m_hInstance, (DLGTEMPLATE*)(*i)->hGlobal, AfxGetMainWnd()->m_hWnd, MainVSTDlgProc);

	//Inicjalizacja suwakw:
	for (j = 0; j < m_pOpenEffect->numParams; j++)
	{
		hDlgItem = GetDlgItem(m_hWnd, ID_VST_STATIC + m_pOpenEffect->numParams + j);

		bParamValue = (BYTE) 255*m_pOpenEffect->getParameter(m_pOpenEffect, j);

		SendMessage(hDlgItem, TBM_SETRANGE, 
        (WPARAM) TRUE,					// redraw flag 
        (LPARAM) MAKELONG(0, 255));		// min. & max.

		SendMessage(hDlgItem, TBM_SETPAGESIZE, 
        0, (LPARAM) 4);                 
 
		SendMessage(hDlgItem, TBM_SETSEL, 
        (WPARAM) FALSE,					// redraw flag 
        (LPARAM) MAKELONG(0, 255)); 

		SendMessage(hDlgItem, TBM_SETPOS, 
        (WPARAM) TRUE,					// redraw flag 
        (LPARAM) bParamValue); 
	}

	ShowWindow(m_hWnd, SW_SHOW);
	
}

BOOL CALLBACK VSTPlugin::MainVSTDlgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	//HGDIOBJ hTmpObject;
	//PAINTSTRUCT ps;
	//HDC hDC;
	char /*ParamName[9],*/ ParamDisplay[17], ParamLabel[9];
	//float ParamValue;
	BYTE  bParamValue;
	HWND  hDlgItem;
	int   ctrlNum;

	switch( msg )
	{
		case WM_CLOSE:
		{
			//EndDialog(hWnd, wParam);
			DestroyWindow(hWnd);
			break;
		}

		case WM_INITDIALOG:
			{
				return true;
				break;
			}

		case WM_HSCROLL:
			{
				hDlgItem = (HWND) lParam;
				bParamValue = SendMessage(hDlgItem, TBM_GETPOS, 0, 0);
				ctrlNum = GetDlgCtrlID(hDlgItem) - ID_VST_STATIC - m_pOpenEffect->numParams;
				m_pOpenEffect->setParameter(m_pOpenEffect, ctrlNum, (float) bParamValue/255);
				hDlgItem = GetDlgItem(m_hWnd, GetDlgCtrlID(hDlgItem) + m_pOpenEffect->numParams);
				m_pOpenEffect->dispatcher(m_pOpenEffect, effGetParamDisplay, ctrlNum, 0, ParamDisplay, 0.0f);
				m_pOpenEffect->dispatcher(m_pOpenEffect, effGetParamLabel, ctrlNum, 0, ParamLabel, 0.0f);
				lstrcat(ParamDisplay, ParamLabel);
				SetWindowText(hDlgItem, ParamDisplay);
				break;
			}

	default:
		return 0; // DefWindowProc( hWnd, msg, wParam, lParam );
	}

	return 0;
}

BOOL CALLBACK VSTPlugin::MainVSTDlgProc2(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg)
	{
	case WM_CLOSE:
		{
			DestroyWindow(hWnd);
			//EndDialog(hWnd, wParam);
			break;
		}

	case WM_INITDIALOG:
		{
			return true;
			break;
		}

	default:
		return 0;
	}

	return 0;
}

bool VSTPlugin::GetDataBlock(char* Out, DWORD* sFilled, DWORD PlayPosition)
{
	list<Effect*>::iterator i;

	if (!PluginChain.empty())
	{
		float* fOut[2] = {(new float[BlockSize/4]), (new float[BlockSize/4])};

		i = PluginChain.end();
		i--;
	
		Work(i, fOut, PlayPosition);
		BufferToShort(fOut, Out, BlockSize >> 2); //SAMPLE NIE BAJTY!
		//Kiedy ja to uporzadkuje... ????
		*sFilled = sLastFilled;

		delete fOut[0];
		delete fOut[1];
	}
	else DataServer->GetDataBlock(Out, BlockSize >> 2, sFilled, PlayPosition);

	//Uwaga - proteza!
	return true;
}

void VSTPlugin::Work(list<Effect*>::iterator i, float** fOut, DWORD PlayPosition)
{
	//auto_ptr<char> Buffer(new char[BlockSize]);
//	Effect* x = *i;
	if (i == PluginChain.begin())
	{
		DataServer->GetDataBlock(cWorkBuffer, BlockSize >> 2, &sLastFilled, PlayPosition);
		//Engine przyjmuje wartosci w samplach a nie w bajtach, wiec >> 2.
		BufferToFloat(cWorkBuffer, fWorkBuffer, sLastFilled);
		(*i)->pAEffect->processReplacing((*i)->pAEffect, fWorkBuffer, fOut, sLastFilled);
	}
	else 
	{
		list<Effect*>::iterator j = i;
		Work(--j, fOut, PlayPosition);
		CopyMemory(fWorkBuffer, fOut, sLastFilled);
		(*i)->pAEffect->processReplacing((*i)->pAEffect, fWorkBuffer, fOut, sLastFilled);
	}
}

char* VSTPlugin::GetPluginName(int pos)
{
	for (list<AllPluginsEntry>::iterator i = AllPluginNames.begin(); i != AllPluginNames.end(); ++i)
	{
		if(!(pos--)) return (*i).Name;
	}
	return 0;
}

char* VSTPlugin::GetPluginDllName(int pos)
{
	for (list<AllPluginsEntry>::iterator i = AllPluginNames.begin(); i != AllPluginNames.end(); ++i)
	{
		if(!(pos--)) return (*i).DllName;
	}
	return 0;
}


void VSTPlugin::BufferToFloat(char* In, float **Out, DWORD bSize)
{
	//Tutaj po raz kolejny nalezy przypomniec, ze bSize jest iloscia SAMPLI a nie bajtow :)
  short* p=(short*) In;
	for (int i = 0; i < bSize; i++)
	{
		Out[0][i] = p[i*2]  / 65536.0f; //Nawiasy?
		Out[1][i] = p[i*2+1] / 65536.0f;
	}
}

void VSTPlugin::BufferToShort(float**In, char* Out, DWORD bSize)
{
	short* p = (short*) Out;
	for (int i = 0; i < bSize; i++)
	{
		p[i*2] = In[0][i] * 65536.0f;
		p[i*2+1] = In[1][i] * 65536.0f;
	}
}

WORD* VSTPlugin::Align2DWORD(WORD* pIn)
{
	ULONG ul;

    ul = (ULONG) pIn;
    ul+=3;
    ul&=0xfffffffc;
	
    return (WORD*) ul;
}

bool VSTPlugin::IsEmpty(void)
{
	return PluginChain.empty();
}